<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Lifinity Dungeon: He_Arc::RPG::Room Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Lifinity Dungeon
   &#160;<span id="projectnumber">6</span>
   </div>
   <div id="projectbrief">The Lifinity Dungeon is a dungeon with an infinity of room. After each room, you found a harder room. This is why you will pass the eternity of your life in this dungeon</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><b>He_Arc</b></li><li class="navelem"><b>RPG</b></li><li class="navelem"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html">Room</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="class_he___arc_1_1_r_p_g_1_1_room-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">He_Arc::RPG::Room Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>The room is where the characters can do a fight. It contains lanes, and handle the laning (move character on lanes) The room also contains the team configuration infos.  
 <a href="class_he___arc_1_1_r_p_g_1_1_room.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_room_8hpp_source.html">Room.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a5c84031f662272268c909354147d1555"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#a5c84031f662272268c909354147d1555">LaneName</a> { <br />
&#160;&#160;<b>BackLaneLeftSide</b> = 1
, <b>MidLaneLeftSide</b>
, <b>FrontLaneLeftSide</b>
, <b>FrontLaneRightSide</b>
, <br />
&#160;&#160;<b>MidLaneRightSide</b>
, <b>BackLaneRightSide</b>
, <b>DeadRightSide</b> = -1
, <b>DeadLeftSide</b> = -2
, <br />
&#160;&#160;<b>None</b> = -3
<br />
 }</td></tr>
<tr class="memdesc:a5c84031f662272268c909354147d1555"><td class="mdescLeft">&#160;</td><td class="mdescRight">The name of each possible lane in the room.  <a href="class_he___arc_1_1_r_p_g_1_1_room.html#a5c84031f662272268c909354147d1555">More...</a><br /></td></tr>
<tr class="separator:a5c84031f662272268c909354147d1555"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a1fe858581162638959f82cee043d89ef"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#a1fe858581162638959f82cee043d89ef">Room</a> (vector&lt; shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt;&gt; team1, vector&lt; shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt;&gt; team2)</td></tr>
<tr class="memdesc:a1fe858581162638959f82cee043d89ef"><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct a new <a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html" title="The room is where the characters can do a fight. It contains lanes, and handle the laning (move chara...">Room</a> object.  <a href="class_he___arc_1_1_r_p_g_1_1_room.html#a1fe858581162638959f82cee043d89ef">More...</a><br /></td></tr>
<tr class="separator:a1fe858581162638959f82cee043d89ef"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a78519febcb43813c3a8129d5b58bd22f"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#a78519febcb43813c3a8129d5b58bd22f">IsFightMoveAllowed</a> (shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt; character, <a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#a5c84031f662272268c909354147d1555">LaneName</a> dest)</td></tr>
<tr class="memdesc:a78519febcb43813c3a8129d5b58bd22f"><td class="mdescLeft">&#160;</td><td class="mdescRight">is the character can move on this lane (only use for moving between "fighting lane"  <a href="class_he___arc_1_1_r_p_g_1_1_room.html#a78519febcb43813c3a8129d5b58bd22f">More...</a><br /></td></tr>
<tr class="separator:a78519febcb43813c3a8129d5b58bd22f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3b5c4b3e4ee3c076c489a2c4ead5969c"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#a3b5c4b3e4ee3c076c489a2c4ead5969c">IsMoveAllowed</a> (shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt; character, <a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#a5c84031f662272268c909354147d1555">LaneName</a> dest)</td></tr>
<tr class="memdesc:a3b5c4b3e4ee3c076c489a2c4ead5969c"><td class="mdescLeft">&#160;</td><td class="mdescRight">is the character can move on this lane  <a href="class_he___arc_1_1_r_p_g_1_1_room.html#a3b5c4b3e4ee3c076c489a2c4ead5969c">More...</a><br /></td></tr>
<tr class="separator:a3b5c4b3e4ee3c076c489a2c4ead5969c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae98685e85bc3e4a66fd14debe5e85f5f"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#ae98685e85bc3e4a66fd14debe5e85f5f">MoveCharacterOneLane</a> (shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt; character, bool isRightMove)</td></tr>
<tr class="memdesc:ae98685e85bc3e4a66fd14debe5e85f5f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Move the character on the lane to their right or left.  <a href="class_he___arc_1_1_r_p_g_1_1_room.html#ae98685e85bc3e4a66fd14debe5e85f5f">More...</a><br /></td></tr>
<tr class="separator:ae98685e85bc3e4a66fd14debe5e85f5f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a201cf61548deaa10252b571d05497f92"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#a201cf61548deaa10252b571d05497f92">MoveCharacterToLane</a> (shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt; character, <a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#a5c84031f662272268c909354147d1555">LaneName</a> destination)</td></tr>
<tr class="memdesc:a201cf61548deaa10252b571d05497f92"><td class="mdescLeft">&#160;</td><td class="mdescRight">Move the character to the specified lane.  <a href="class_he___arc_1_1_r_p_g_1_1_room.html#a201cf61548deaa10252b571d05497f92">More...</a><br /></td></tr>
<tr class="separator:a201cf61548deaa10252b571d05497f92"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2d3dc2b8fe7d736f1f872f0e2b61cf11"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#a2d3dc2b8fe7d736f1f872f0e2b61cf11">MoveToDeadLane</a> (shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt; character)</td></tr>
<tr class="memdesc:a2d3dc2b8fe7d736f1f872f0e2b61cf11"><td class="mdescLeft">&#160;</td><td class="mdescRight">Move the character to the deadlane of his team.  <a href="class_he___arc_1_1_r_p_g_1_1_room.html#a2d3dc2b8fe7d736f1f872f0e2b61cf11">More...</a><br /></td></tr>
<tr class="separator:a2d3dc2b8fe7d736f1f872f0e2b61cf11"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aca603393006654d28b83f957de4f97ed"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#a5c84031f662272268c909354147d1555">LaneName</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#aca603393006654d28b83f957de4f97ed">GetLaneOfCharacter</a> (const shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt; &amp;character)</td></tr>
<tr class="memdesc:aca603393006654d28b83f957de4f97ed"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the <a class="el" href="class_he___arc_1_1_r_p_g_1_1_lane.html" title="A lane is a part of a room, one lane have 0-N characters on it. It can be compared to the &quot;cell&quot; of t...">Lane</a> where the character is actually.  <a href="class_he___arc_1_1_r_p_g_1_1_room.html#aca603393006654d28b83f957de4f97ed">More...</a><br /></td></tr>
<tr class="separator:aca603393006654d28b83f957de4f97ed"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af8c94964014bfb260a1772a33d3a3533"><td class="memItemLeft" align="right" valign="top">vector&lt; shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#af8c94964014bfb260a1772a33d3a3533">GetCharactersOnLane</a> (const <a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#a5c84031f662272268c909354147d1555">LaneName</a> laneName, bool onlyFightLane, <a class="el" href="_enums_8hpp.html#ad46aac46ff35875d2e579285bc6289b9">TeamGrp</a> specifiedTeam=TeamGrp::None)</td></tr>
<tr class="memdesc:af8c94964014bfb260a1772a33d3a3533"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the Characters present on the lane.  <a href="class_he___arc_1_1_r_p_g_1_1_room.html#af8c94964014bfb260a1772a33d3a3533">More...</a><br /></td></tr>
<tr class="separator:af8c94964014bfb260a1772a33d3a3533"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae8e145d0ceade2921652dee247579677"><td class="memItemLeft" align="right" valign="top">vector&lt; shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#ae8e145d0ceade2921652dee247579677">GetNeighbourCharacters</a> (const shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt; source, int direction, <a class="el" href="_enums_8hpp.html#ad46aac46ff35875d2e579285bc6289b9">TeamGrp</a> specifiedTeam=TeamGrp::None)</td></tr>
<tr class="memdesc:ae8e145d0ceade2921652dee247579677"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the Neighbour of the character (characters near the "source") If "from" is on left middle lane; the "direction" is 1; it will return the characters on the left front lane.  <a href="class_he___arc_1_1_r_p_g_1_1_room.html#ae8e145d0ceade2921652dee247579677">More...</a><br /></td></tr>
<tr class="separator:ae8e145d0ceade2921652dee247579677"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad002566ba5741d437b00e52c893bdf4f"><td class="memItemLeft" align="right" valign="top"><a class="el" href="_enums_8hpp.html#ad46aac46ff35875d2e579285bc6289b9">TeamGrp</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#ad002566ba5741d437b00e52c893bdf4f">GetTeamOfCharacter</a> (const shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt; &amp;character)</td></tr>
<tr class="memdesc:ad002566ba5741d437b00e52c893bdf4f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the <a class="el" href="class_he___arc_1_1_r_p_g_1_1_lane.html" title="A lane is a part of a room, one lane have 0-N characters on it. It can be compared to the &quot;cell&quot; of t...">Lane</a> where the character is actually.  <a href="class_he___arc_1_1_r_p_g_1_1_room.html#ad002566ba5741d437b00e52c893bdf4f">More...</a><br /></td></tr>
<tr class="separator:ad002566ba5741d437b00e52c893bdf4f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a48c2913d8de2a04a6068f8b2e0db761c"><td class="memItemLeft" align="right" valign="top"><a id="a48c2913d8de2a04a6068f8b2e0db761c"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#a48c2913d8de2a04a6068f8b2e0db761c">ShowRoomInfo</a> () const</td></tr>
<tr class="memdesc:a48c2913d8de2a04a6068f8b2e0db761c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Display the lane info : the teams, the lanes info. <br /></td></tr>
<tr class="separator:a48c2913d8de2a04a6068f8b2e0db761c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afbab5c77233abc25381cb78b06e3c97a"><td class="memItemLeft" align="right" valign="top"><a id="afbab5c77233abc25381cb78b06e3c97a"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#afbab5c77233abc25381cb78b06e3c97a">DisplayRoom</a> () const</td></tr>
<tr class="memdesc:afbab5c77233abc25381cb78b06e3c97a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Display the room "graphically". <br /></td></tr>
<tr class="separator:afbab5c77233abc25381cb78b06e3c97a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:a10fefae9f3e36dd00f073a576f77492b"><td class="memItemLeft" align="right" valign="top"><a id="a10fefae9f3e36dd00f073a576f77492b"></a>
const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#a10fefae9f3e36dd00f073a576f77492b">FIRST_FIGHT_LANE</a> = 1</td></tr>
<tr class="memdesc:a10fefae9f3e36dd00f073a576f77492b"><td class="mdescLeft">&#160;</td><td class="mdescRight">The Start index of fighting lanes. <br /></td></tr>
<tr class="separator:a10fefae9f3e36dd00f073a576f77492b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8264718242a33b73a4ebc3520d1e56ee"><td class="memItemLeft" align="right" valign="top">const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#a8264718242a33b73a4ebc3520d1e56ee">ROOM_FIGHT_LANE_SIZE</a> = 6</td></tr>
<tr class="memdesc:a8264718242a33b73a4ebc3520d1e56ee"><td class="mdescLeft">&#160;</td><td class="mdescRight">The quantity of fighting lanes.  <a href="class_he___arc_1_1_r_p_g_1_1_room.html#a8264718242a33b73a4ebc3520d1e56ee">More...</a><br /></td></tr>
<tr class="separator:a8264718242a33b73a4ebc3520d1e56ee"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac9f35a204bf0f8f3d99888a8051df286"><td class="memItemLeft" align="right" valign="top">map&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#a5c84031f662272268c909354147d1555">LaneName</a>, shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_lane.html">Lane</a> &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#ac9f35a204bf0f8f3d99888a8051df286">LaneNameToLane</a></td></tr>
<tr class="memdesc:ac9f35a204bf0f8f3d99888a8051df286"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert a LaneName value to the corresponding lane object.  <a href="class_he___arc_1_1_r_p_g_1_1_room.html#ac9f35a204bf0f8f3d99888a8051df286">More...</a><br /></td></tr>
<tr class="separator:ac9f35a204bf0f8f3d99888a8051df286"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ade1fe7f58277a6df414c3d6bf6e09319"><td class="memItemLeft" align="right" valign="top">map&lt; shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_lane.html">Lane</a> &gt;, <a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#a5c84031f662272268c909354147d1555">LaneName</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#ade1fe7f58277a6df414c3d6bf6e09319">LaneToLaneName</a></td></tr>
<tr class="memdesc:ade1fe7f58277a6df414c3d6bf6e09319"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert a lane object to the corresponding LaneName value.  <a href="class_he___arc_1_1_r_p_g_1_1_room.html#ade1fe7f58277a6df414c3d6bf6e09319">More...</a><br /></td></tr>
<tr class="separator:ade1fe7f58277a6df414c3d6bf6e09319"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>The room is where the characters can do a fight. It contains lanes, and handle the laning (move character on lanes) The room also contains the team configuration infos. </p>
</div><h2 class="groupheader">Member Enumeration Documentation</h2>
<a id="a5c84031f662272268c909354147d1555"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5c84031f662272268c909354147d1555">&#9670;&nbsp;</a></span>LaneName</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#a5c84031f662272268c909354147d1555">He_Arc::RPG::Room::LaneName</a></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>The name of each possible lane in the room. </p>
<dl class="section remark"><dt>Remarks</dt><dd>if add new lanes, modify variable ROOM_FIGHT_LANE_SIZE and FIRST_FIGHT_LANE </dd></dl>

</div>
</div>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a1fe858581162638959f82cee043d89ef"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1fe858581162638959f82cee043d89ef">&#9670;&nbsp;</a></span>Room()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Room::Room </td>
          <td>(</td>
          <td class="paramtype">vector&lt; shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt;&gt;&#160;</td>
          <td class="paramname"><em>team1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">vector&lt; shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt;&gt;&#160;</td>
          <td class="paramname"><em>team2</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Construct a new <a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html" title="The room is where the characters can do a fight. It contains lanes, and handle the laning (move chara...">Room</a> object. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">team1</td><td>Team who will be placed on the left side </td></tr>
    <tr><td class="paramname">team2</td><td>Team who will be placed on the right side </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="af8c94964014bfb260a1772a33d3a3533"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af8c94964014bfb260a1772a33d3a3533">&#9670;&nbsp;</a></span>GetCharactersOnLane()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">vector&lt; shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt; &gt; Room::GetCharactersOnLane </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#a5c84031f662272268c909354147d1555">LaneName</a>&#160;</td>
          <td class="paramname"><em>laneName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>onlyFightLane</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="_enums_8hpp.html#ad46aac46ff35875d2e579285bc6289b9">TeamGrp</a>&#160;</td>
          <td class="paramname"><em>specifiedTeam</em> = <code>TeamGrp::None</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the Characters present on the lane. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">LaneName</td><td><a class="el" href="class_he___arc_1_1_r_p_g_1_1_lane.html" title="A lane is a part of a room, one lane have 0-N characters on it. It can be compared to the &quot;cell&quot; of t...">Lane</a> to get </td></tr>
    <tr><td class="paramname">onlyFightLane</td><td>Is the method need to check if lanes are used for fighting </td></tr>
    <tr><td class="paramname">specifiedTeam</td><td>get only characters if they was in the specified team If "None" : get all characters (no matter the team) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>vector&lt;shared_ptr&lt;CharacterClass&gt;&gt; Characters on the specified lane </dd></dl>

</div>
</div>
<a id="aca603393006654d28b83f957de4f97ed"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aca603393006654d28b83f957de4f97ed">&#9670;&nbsp;</a></span>GetLaneOfCharacter()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#a5c84031f662272268c909354147d1555">Room::LaneName</a> Room::GetLaneOfCharacter </td>
          <td>(</td>
          <td class="paramtype">const shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt; &amp;&#160;</td>
          <td class="paramname"><em>character</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the <a class="el" href="class_he___arc_1_1_r_p_g_1_1_lane.html" title="A lane is a part of a room, one lane have 0-N characters on it. It can be compared to the &quot;cell&quot; of t...">Lane</a> where the character is actually. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">character</td><td>character to get the lane </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><a class="el" href="class_he___arc_1_1_r_p_g_1_1_lane.html" title="A lane is a part of a room, one lane have 0-N characters on it. It can be compared to the &quot;cell&quot; of t...">Lane</a> the lane where the character is </dd></dl>

</div>
</div>
<a id="ae8e145d0ceade2921652dee247579677"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae8e145d0ceade2921652dee247579677">&#9670;&nbsp;</a></span>GetNeighbourCharacters()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">vector&lt; shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt; &gt; Room::GetNeighbourCharacters </td>
          <td>(</td>
          <td class="paramtype">const shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt;&#160;</td>
          <td class="paramname"><em>source</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>direction</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="_enums_8hpp.html#ad46aac46ff35875d2e579285bc6289b9">TeamGrp</a>&#160;</td>
          <td class="paramname"><em>specifiedTeam</em> = <code>TeamGrp::None</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the Neighbour of the character (characters near the "source") If "from" is on left middle lane; the "direction" is 1; it will return the characters on the left front lane. </p>
<dl class="section remark"><dt>Remarks</dt><dd>get only neighbour in the fighting lanes</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">source</td><td>character to get neighbour </td></tr>
    <tr><td class="paramname">direction</td><td>Neighbour at which position from the "source" </td></tr>
    <tr><td class="paramname">specifiedTeam</td><td>get only characters if they was in the specified team If "None" : get all characters (no matter the team) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>vector&lt;shared_ptr&lt;CharacterClass&gt;&gt; Neighbour of the character at the distance of "neighbourDirection" </dd></dl>

</div>
</div>
<a id="ad002566ba5741d437b00e52c893bdf4f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad002566ba5741d437b00e52c893bdf4f">&#9670;&nbsp;</a></span>GetTeamOfCharacter()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="_enums_8hpp.html#ad46aac46ff35875d2e579285bc6289b9">TeamGrp</a> Room::GetTeamOfCharacter </td>
          <td>(</td>
          <td class="paramtype">const shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt; &amp;&#160;</td>
          <td class="paramname"><em>character</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the <a class="el" href="class_he___arc_1_1_r_p_g_1_1_lane.html" title="A lane is a part of a room, one lane have 0-N characters on it. It can be compared to the &quot;cell&quot; of t...">Lane</a> where the character is actually. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">character</td><td>character to get the lane </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><a class="el" href="class_he___arc_1_1_r_p_g_1_1_lane.html" title="A lane is a part of a room, one lane have 0-N characters on it. It can be compared to the &quot;cell&quot; of t...">Lane</a> the lane where the character is </dd></dl>

</div>
</div>
<a id="a78519febcb43813c3a8129d5b58bd22f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a78519febcb43813c3a8129d5b58bd22f">&#9670;&nbsp;</a></span>IsFightMoveAllowed()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Room::IsFightMoveAllowed </td>
          <td>(</td>
          <td class="paramtype">shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt;&#160;</td>
          <td class="paramname"><em>character</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#a5c84031f662272268c909354147d1555">LaneName</a>&#160;</td>
          <td class="paramname"><em>dest</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>is the character can move on this lane (only use for moving between "fighting lane" </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">character</td><td>Character to move </td></tr>
    <tr><td class="paramname">dest</td><td><a class="el" href="class_he___arc_1_1_r_p_g_1_1_lane.html" title="A lane is a part of a room, one lane have 0-N characters on it. It can be compared to the &quot;cell&quot; of t...">Lane</a> where the character go </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true The character can move on the lane </dd>
<dd>
false The character can't move on the lane </dd></dl>

</div>
</div>
<a id="a3b5c4b3e4ee3c076c489a2c4ead5969c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3b5c4b3e4ee3c076c489a2c4ead5969c">&#9670;&nbsp;</a></span>IsMoveAllowed()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Room::IsMoveAllowed </td>
          <td>(</td>
          <td class="paramtype">shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt;&#160;</td>
          <td class="paramname"><em>character</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#a5c84031f662272268c909354147d1555">LaneName</a>&#160;</td>
          <td class="paramname"><em>dest</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>is the character can move on this lane </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">character</td><td>Character to move </td></tr>
    <tr><td class="paramname">dest</td><td><a class="el" href="class_he___arc_1_1_r_p_g_1_1_lane.html" title="A lane is a part of a room, one lane have 0-N characters on it. It can be compared to the &quot;cell&quot; of t...">Lane</a> where the character go </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true The character can move on the lane </dd>
<dd>
false The character can't move on the lane </dd></dl>

</div>
</div>
<a id="ae98685e85bc3e4a66fd14debe5e85f5f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae98685e85bc3e4a66fd14debe5e85f5f">&#9670;&nbsp;</a></span>MoveCharacterOneLane()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Room::MoveCharacterOneLane </td>
          <td>(</td>
          <td class="paramtype">shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt;&#160;</td>
          <td class="paramname"><em>character</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>isRightMove</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Move the character on the lane to their right or left. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">character</td><td>character to move </td></tr>
    <tr><td class="paramname">isRightMove</td><td>true : Move to the right, false : Move to the left (only for moving in fight lane)</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if the move is success </dd>
<dd>
false if the move fail (character is not on a "fight" lane, or the move is out of "fight" lanes of the room or the lane is possessed by other team) </dd></dl>

</div>
</div>
<a id="a201cf61548deaa10252b571d05497f92"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a201cf61548deaa10252b571d05497f92">&#9670;&nbsp;</a></span>MoveCharacterToLane()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Room::MoveCharacterToLane </td>
          <td>(</td>
          <td class="paramtype">shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt;&#160;</td>
          <td class="paramname"><em>character</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#a5c84031f662272268c909354147d1555">LaneName</a>&#160;</td>
          <td class="paramname"><em>destination</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Move the character to the specified lane. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">character</td><td>character to move </td></tr>
    <tr><td class="paramname">destination</td><td><a class="el" href="class_he___arc_1_1_r_p_g_1_1_lane.html" title="A lane is a part of a room, one lane have 0-N characters on it. It can be compared to the &quot;cell&quot; of t...">Lane</a> where the character will be</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if the move is success </dd>
<dd>
false if the move fail if the lane is possessed by other team) </dd></dl>

</div>
</div>
<a id="a2d3dc2b8fe7d736f1f872f0e2b61cf11"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2d3dc2b8fe7d736f1f872f0e2b61cf11">&#9670;&nbsp;</a></span>MoveToDeadLane()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Room::MoveToDeadLane </td>
          <td>(</td>
          <td class="paramtype">shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &gt;&#160;</td>
          <td class="paramname"><em>character</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Move the character to the deadlane of his team. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">character</td><td>Character to move </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="ac9f35a204bf0f8f3d99888a8051df286"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac9f35a204bf0f8f3d99888a8051df286">&#9670;&nbsp;</a></span>LaneNameToLane</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">map&lt;<a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#a5c84031f662272268c909354147d1555">LaneName</a>, shared_ptr&lt;<a class="el" href="class_he___arc_1_1_r_p_g_1_1_lane.html">Lane</a>&gt; &gt; He_Arc::RPG::Room::LaneNameToLane</td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Initial value:</b><div class="fragment"><div class="line">= {</div>
<div class="line">            {LaneName::BackLaneLeftSide, m_backLaneLeftSide},</div>
<div class="line">            {LaneName::MidLaneLeftSide, m_midLaneLeftSide},</div>
<div class="line">            {LaneName::FrontLaneLeftSide, m_frontLaneLeftSide},</div>
<div class="line">            {LaneName::FrontLaneRightSide, m_frontLaneRightSide},</div>
<div class="line">            {LaneName::MidLaneRightSide, m_midLaneRightSide},</div>
<div class="line">            {LaneName::BackLaneRightSide, m_backLaneRightSide},</div>
<div class="line">            {LaneName::DeadLeftSide, m_deadLaneLeftSide},</div>
<div class="line">            {LaneName::DeadRightSide, m_deadLaneRightSide},</div>
<div class="line">            {LaneName::None, <span class="keyword">nullptr</span>}}</div>
</div><!-- fragment -->
<p>Convert a LaneName value to the corresponding lane object. </p>

</div>
</div>
<a id="ade1fe7f58277a6df414c3d6bf6e09319"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ade1fe7f58277a6df414c3d6bf6e09319">&#9670;&nbsp;</a></span>LaneToLaneName</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">map&lt;shared_ptr&lt;<a class="el" href="class_he___arc_1_1_r_p_g_1_1_lane.html">Lane</a>&gt;, <a class="el" href="class_he___arc_1_1_r_p_g_1_1_room.html#a5c84031f662272268c909354147d1555">LaneName</a>&gt; He_Arc::RPG::Room::LaneToLaneName</td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Initial value:</b><div class="fragment"><div class="line">= {</div>
<div class="line">            {m_backLaneLeftSide, LaneName::BackLaneLeftSide},</div>
<div class="line">            {m_midLaneLeftSide, LaneName::MidLaneLeftSide},</div>
<div class="line">            {m_frontLaneLeftSide, LaneName::FrontLaneLeftSide},</div>
<div class="line">            {m_frontLaneRightSide, LaneName::FrontLaneRightSide},</div>
<div class="line">            {m_midLaneRightSide, LaneName::MidLaneRightSide},</div>
<div class="line">            {m_backLaneRightSide, LaneName::BackLaneRightSide},</div>
<div class="line">            {m_deadLaneLeftSide, LaneName::DeadLeftSide},</div>
<div class="line">            {m_deadLaneRightSide, LaneName::DeadRightSide},</div>
<div class="line">            {<span class="keyword">nullptr</span>, LaneName::None}}</div>
</div><!-- fragment -->
<p>Convert a lane object to the corresponding LaneName value. </p>

</div>
</div>
<a id="a8264718242a33b73a4ebc3520d1e56ee"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8264718242a33b73a4ebc3520d1e56ee">&#9670;&nbsp;</a></span>ROOM_FIGHT_LANE_SIZE</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const int He_Arc::RPG::Room::ROOM_FIGHT_LANE_SIZE = 6</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>The quantity of fighting lanes. </p>
<dl class="section remark"><dt>Remarks</dt><dd>the size is linked to the number of positive (&gt;0) value in LaneName Enum </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>cpp_filrouge_iscj_allemann/include/Room/<a class="el" href="_room_8hpp_source.html">Room.hpp</a></li>
<li>cpp_filrouge_iscj_allemann/src/Room/<a class="el" href="_room_8cpp.html">Room.cpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
